local BufferedInput = Object:extend()


function BufferedInput:new(target)
  self.target = target
  self.buffer = {}
end

function BufferedInput:dispatch_press(key)
  table.insert(self.buffer, {'dispatch_press', key})
end

function BufferedInput:dispatch_release(key)
  table.insert(self.buffer, {'dispatch_release', key})
end

function BufferedInput:text_input(text)
  table.insert(self.buffer, {'text_input', key})
end

function BufferedInput:dispatch()
  local c = #self.buffer
  for i = 1, c do
    local b = self.buffer[i]
    self.target[b[1]](self.target, b[2])
    self.buffer[i] = nil
  end
end

function BufferedInput:prepare()

end

return BufferedInput
