Camera = Object:extend()

function Camera:new(state)
	self.state = state
	self.cx = 0
	self.cy = 0
  self.tx = 0
  self.ty = 0
  self.ox = 0
  self.oy = 0
  self.x = 0
  self.y = 0
end

local vscalex = 0.4
local vscaley = 0.3
function Camera:update(dt)
	if self.tracked then
		self.cx, self.cy = self.tracked:getPos()
		local vx, vy = 0, 0
		if self.tracked.getVel then
			vx, vy = self.tracked:getVel()
			vx = vx * vscalex
			vy = vy * vscaley
		end

		self.tx, self.ty = vx, vy

--		self.tx = x
--		self.ty = y
--		self.x = x
--		self.y = y
	end

	local dx, dy = (self.tx - self.ox), (self.ty - self.oy)

  self.ox = self.ox + dx * 0.01
  self.oy = self.oy + dy * 0.005
  

	self.x = self.cx + self.ox
  self.y = self.cy + self.oy

end


function Camera:updateGfx(dt)
end


function Camera:track(obj)
	self.tracked = obj
  if obj then
    self.x, self.y = self.tracked:getPos()
  end
end


function Camera:setup()
	local w, h = love.graphics.getDimensions()
	love.graphics.translate(math.floor(-self.x + w / 2), math.floor(-self.y *renderScale + h / 2))
end
