async = require "asynchttprequest"
CountdownState = lust.Gamestate:extend()

function CountdownState:new(ingameState)
  self.ingameState = ingameState
  self.flux = flux.group()

  self.offset = 0
  self.time = 3

  if not G.headless then
    G.sounds.countdown_short:play()
  end
  self.flux:to(self, 0.66, {time = 2}):oncomplete(function()
    if not G.headless then
      G.sounds.countdown_short:play()
    end
    self.flux:to(self, 0.66, {time = 1}):oncomplete(function()
      if not G.headless then
        G.sounds.countdown_short:play()
      end
      self.flux:to(self, 0.66, {time = 0}):oncomplete(function()
        if not G.headless then
          G.sounds.countdown_long:play()
          self.flux:to(self, 0.2, {offset = -love.graphics.getWidth()})
        end
        --self.ingameState.countdown = false
        self.flux:to(self, 1, {time = -1}):oncomplete(function()
          G.core.states:pop()
        end)
      end)
    end)
  end)


  if not G.headless then
    self.best = G.highscores:get(self.ingameState.trackData.filename)
    if self.best ~= math.huge then
      self.hs_offset = 0
      self.hst_offset = 0
      
      self.flux:to(self, 0.2, {hs_offset = -love.graphics.getWidth()}):delay(1.3)
      self.flux:to(self, 0.2, {hst_offset = love.graphics.getWidth()}):delay(1.1)
    end
  end

  self.timeBacklog = 0

end

local stepSize = 0.01
function CountdownState:update(dt)
  self.timeBacklog = self.timeBacklog + dt
  self.ingameState:update(dt)
  while self.timeBacklog >= stepSize do
    self.flux:update(stepSize)

    if self.ingameState.time == 200 then
      G.core.states:pop()
--      self.ingameState.countdown = false
    end
    self.timeBacklog = self.timeBacklog - stepSize
  end
end

function CountdownState:draw()
  if G.headless then
    return
  end

  self.ingameState:draw()

  local w, h = love.graphics.getDimensions()
  love.graphics.setColor(0,0,0, 200)
  love.graphics.rectangle('fill', self.offset, 170, w, G.largeFont:getHeight() + 60)

  love.graphics.setFont(G.largeFont)
  if self.time > 0 then
    local alpha = math.fmod(self.time, 1.0) * 255
    love.graphics.setColor(255,255,255,alpha)
    love.graphics.printf(math.ceil(self.time), 0, 200, w, 'center')
  else
    local alpha = 255
    if self.time < -0.8 then
      alpha = 5*(self.time + 1)*255
    end
    love.graphics.setColor(255,255,255,alpha)
    love.graphics.printf("go!", 0, 200, w, 'center')
  end

  if self.hs_offset then
    love.graphics.setColor(0,0,0,200)
    love.graphics.rectangle('fill', self.hs_offset, 500, w, G.smallFont:getHeight() + 60)
    love.graphics.setFont(G.smallFont)
    love.graphics.setColor(255,255,255,255)
    local m = math.floor(self.best / 60)
    local s = math.fmod(self.best, 60)
    
    love.graphics.printf(string.format("Best time: %02d:%05.2f", m , s), self.hst_offset, 530, w, 'center')

  end

  love.graphics.setColor(255,255,255,255)

end


function CountdownState:enter()
end

function CountdownState:leave()
end
