ParticlePool = Object:extend()

function ParticlePool:new(state)
  self.state = state
  self.pool = {}

  for i = 1, 600 do
    table.insert(self.pool, Particle(self))
  end

  self.drawable = {}
end


function ParticlePool:create(x, y, s, c, t, i, tq, g)
  if #self.pool == 0 then
    self.pool[1] = Particle(self)
  end

  local particle = table.remove(self.pool)
  particle:setup(x, y, s, c, t, i, tq, g)
  return particle
end


function ParticlePool:returnParticle(particle)
  table.insert(self.pool, particle)
end


function ParticlePool:draw()
  local c = #self.drawable
  for i = 1, c do
    local d = self.drawable[i]
    self.drawable[i] = nil
    
    love.graphics.setColor(d[1], d[2], d[3], d[4])
    love.graphics.setBlendMode(d[7])
    love.graphics.draw(Particle.img, d[5], d[6]*renderScale, 0, d[8], d[8], Particle.offset, Particle.offset)

  end
  love.graphics.setBlendMode('alpha')
end
