

Particle = Object:extend()

Particle.load = function()
  Particle.img = G.core.images:load("data/circle.png")
  local w = Particle.img:getWidth()
  Particle.scale = 2 / w
  Particle.offset = w / 2
end


function Particle:new(pool)
  self.pool = pool
  self.body = love.physics.newBody(self.pool.state.world, 0, 0, 'dynamic')
  self.fixture = love.physics.newFixture(self.body, love.physics.newCircleShape(0, 0, 1), 1 / G.density)
  self.fixture:setCategory(5)
  self.fixture:setMask(2,3,4,5,6,7,8,9,10,11,12,13,14,15,16)
  self.body:setActive(false)
end

function Particle:setup(x, y, s, c, t, i, tq, g)
  self.body:setActive(true)
  self.fixture:getShape():setRadius(s)
  self.body:setPosition(x, y)
  self.body:setLinearVelocity(0,0)
  self.body:applyForce(unpack(i))
  self.body:setGravityScale(g)
  self.t = t
  self.ts = t
  self.c = c
  self.s = s
  self.sts = s
  self.drawMode = 'alpha'
  self.body:resetMassData()
  self.dead = false
end


function Particle:draw()

  local r,g,b = unpack(self.c)
  local x, y = self.body:getWorldCenter()
  local s = self.s * Particle.scale
  table.insert(self.pool.drawable, {r, g, b, self.t/self.ts * 255, x, y, self.drawMode, s})
end


function Particle:updateGfx(dt)

end


function Particle:update(dt)
  self.t = self.t -dt
  if self.dsts then
    local l = self.t / self.ts
    self.s = l * self.dsts + (1-l) * self.sts
  end
  if self.t <= 0 then
    self.dead = true
    self.body:setActive(false)
    self.body:setLinearVelocity(0,0)
    self.body:setPosition(0,0)
  end
end


function Particle:die()
  self.pool:returnParticle(self)
end
